﻿@page "/profile"
@using Microsoft.AspNetCore.Identity;
@using VacationSchedule.Core.Models.DB;
@using System.Net.Http;
@using System.Net.Http.Json;
@inject HttpClient Http;


<h1>Информация о сотруднике.</h1>
<EditForm Model="@exampleModel" OnValidSubmit="@HandleValidSubmit">
    <DataAnnotationsValidator />
    <ValidationSummary />
    <div class="col-md-6">
        <div asp-validation-summary="ModelOnly" class="text-danger"></div>
        <div class="form-group">
            <label class="form-label">Login:</label>
            <InputText class="form-control" disabled="@dis" @bind-Value="exampleModel.Login" />
        </div>
        <div class="form-group">
            <label class="form-label">Имя:</label>
            <InputText class="form-control" @bind-Value="exampleModel.FirstName" />
        </div>
        <div class="form-group">
            <label class="form-label">Фамилия:</label>
            <InputText class="form-control" @bind-Value="exampleModel.LastName" />
        </div>
        <div class="form-group">
            <label class="form-label">Отчество:</label>
            <InputText class="form-control" @bind-Value="exampleModel.PatronymicName" />
        </div>
        <button id="update-profile-button" type="submit" class="btn btn-primary">Save</button>
    </div>
</EditForm>

@code {
    [CascadingParameter]
    private Task<AuthenticationState> authenticationStateTask { get; set; }

    private User exampleModel { get; set; } = new ();
    private bool dis = true;

    private async void HandleValidSubmit()
    {
        if (exampleModel.Id == 0)
        {
            await Http.PostAsJsonAsync<User>("api/User", exampleModel);
        }
        else
        {
            await Http.PutAsJsonAsync<User>($"api/User/{exampleModel.Id}", exampleModel);
        }
        //Logger.LogInformation("HandleValidSubmit called");

        // Process the valid form
    }


    protected override async Task OnInitializedAsync()
    {
        var user = (await authenticationStateTask).User;

        if (user.Identity.IsAuthenticated)
        {
            try
            {
                exampleModel = await Http.GetFromJsonAsync<User>($"api/User/GetByUserName?userName={user.Identity.Name}");
            }
            catch(Exception)
            {
                exampleModel.Login = user.Identity.Name; 
            }
        }
        else
        {
            // User is not logged in
        }
    }
}